package net.npaka.keyex;
import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.Window;

//キーイベントの処理
public class KeyEx extends Activity {
    private KeyView     keyView;    //キービュー
    private TickHandler tickHandler;//定期処理ハンドラ
    
    //アプリの初期化(1)
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        keyView=new KeyView(this);
        setContentView(keyView);
    }

    //アプリの再開(1)
    @Override
    public void onResume() {
        super.onResume();
        
        //定期処理ハンドラの開始(3)
        tickHandler=new TickHandler();
        tickHandler.sleep(0);
    }    
    
    //アプリの一時停止(1)
    @Override
    public void onPause() {
        super.onPause();
        
        //定期処理ハンドラの停止(4)
        tickHandler=null;
    }    
    
    //定期処理ハンドラ(2)
    public class TickHandler extends Handler {
        //定期処理
        @Override 
        public void handleMessage(Message msg) {
            keyView.invalidate();
            if (tickHandler!=null) tickHandler.sleep(100);
        }
        
        //スリープ
        public void sleep(long delayMills) {
            removeMessages(0);
            sendMessageDelayed(obtainMessage(0),delayMills);
        }
    }
}