package net.npaka.keyex;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.KeyEvent;
import android.view.View;

//キーイベントの処理
public class KeyView extends View {
    private int keyCode=-999;//キーコード
    
    //コンストラクタ
    public KeyView(Context context) {
        super(context);
        setBackgroundColor(Color.WHITE);

        //フォーカス指定(5)
        setFocusable(true);
        setFocusableInTouchMode(true);
    }
    
    //描画
    @Override 
    protected void onDraw(Canvas canvas) {
        //ペイント
        Paint paint=new Paint();       
        paint.setAntiAlias(true);
        paint.setTextSize(16);
        
        //キーコードの描画
        canvas.drawText("KeyCode>"+keyCode,0,20,paint);
    }
    
    //キーダウンイベントの処理(6)
    @Override 
    public boolean onKeyDown(int keyCode,KeyEvent event) {
        this.keyCode=keyCode;
        return super.onKeyDown(keyCode,event);
    }

    //キーアップイベントの処理(6)
    @Override 
    public boolean onKeyUp(int keyCode,KeyEvent event) {
        this.keyCode=-999;
        return super.onKeyUp(keyCode,event);
    }
}