package net.npaka.stringex;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.View;

//文字列の表示
public class StringView extends View {
    //コンストラクタ
    public StringView(Context context) {
        super(context);
        setBackgroundColor(Color.WHITE);
    }

    //描画
    @Override 
    protected void onDraw(Canvas canvas) {
        //描画オブジェクトの生成
        Paint paint=new Paint();      
        paint.setAntiAlias(true);//(1)
        
        //文字サイズと文字色の指定(2)
        paint.setTextSize(12);
        paint.setColor(Color.argb(255,0,0,0));
        
        //画面サイズの取得(3)     
        canvas.drawText("画面サイズ:"+
            getWidth()+"x"+getHeight(),0,30,paint);
        
        //文字幅の取得(4)
        canvas.drawText("文字幅:"+
            (int)paint.measureText("A"),0,30*2,paint);
        
        //アセントとディセントの取得(5)
        canvas.drawText("アセント:"+
            (int)paint.ascent(),0,30*3,paint);        
        canvas.drawText("ディセント:"+
            (int)paint.descent(),0,30*4,paint);
        
        //12ドットの文字列の表示(6)
        paint.setTextSize(12);
        paint.setColor(Color.argb(255,255,0,0));
        canvas.drawText("12dot",0,30*5,paint);

        //16ドットの文字列の表示
        paint.setTextSize(16);
        paint.setColor(Color.argb(255,0,255,0));
        canvas.drawText("16dot",0,30*6,paint);

        //24ドットの文字列の表示
        paint.setTextSize(24);
        paint.setColor(Color.argb(255,0,0,255));
        canvas.drawText("24dot",0,30*7,paint);        
    }
}