package net.npaka.buttonex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.LinearLayout;

//ボタンとダイアログ
public class ButtonEx extends Activity 
    implements View.OnClickListener {
    private Button      button;     //ボタン
    private ImageButton imageButton;//イメージボタン
        
    //初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);            
        
        //ボタンの生成(1)
        button=new Button(this);
        button.setText("ボタン");
        button.setOnClickListener(this);//(2)
        setLLParams(button);
        layout.addView(button);

        //画像の読み込み
        Bitmap image=BitmapFactory.decodeResource(
            getResources(),R.drawable.mini);        
        
        //イメージボタンの生成(3)
        imageButton=new ImageButton(this);
        imageButton.setImageBitmap(image);
        imageButton.setOnClickListener(this); 
        setLLParams(imageButton);
        layout.addView(imageButton);
    }
    
    //ボタンクリックイベントの処理(2)
    public void onClick(View view) {
        //ボタンを押した時の処理
        if (view==button) {
            showDialog(this,"","ボタンを押した ");
        } 
        //イメージボタンを押した時の処理
        else if (view==imageButton) {
            showDialog(this,"","イメージボタンを押した ");
        }
    }   
    
    //ダイアログの表示(4)
    private static void showDialog(final Activity activity,
        String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(activity);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                activity.setResult(Activity.RESULT_OK);
            }
        });
        ad.create();
        ad.show();
    }

    //ライナーレイアウトのパラメータ指定
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }  
}