package net.npaka.checkboxex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;

//チェックボックスとラジオボタンの利用
public class CheckBoxEx extends Activity 
    implements View.OnClickListener {
    private final static String BR=//改行文字(3)
        System.getProperty("line.separator");
    
    private CheckBox   checkBox;  //チェックボックス
    private RadioGroup radioGroup;//ラジオグループ
    private Button     button;    //ボタン
    
    //初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);             

        //チェックボックスの生成(1)
        checkBox=new CheckBox(this);
        checkBox.setText("チェックボックス");
        checkBox.setTextColor(Color.rgb(0,0,0));
        setLLParams(checkBox);  
        layout.addView(checkBox);

        //ラジオボタン0の生成(2)
        RadioButton radio0=new RadioButton(this);
        radio0.setId(0);
        radio0.setText("ラジオボタン0");
        radio0.setTextColor(Color.rgb(0,0,0));
        
        //ラジオボタン1の生成(2)
        RadioButton radio1=new RadioButton(this);
        radio1.setId(1);
        radio1.setText("ラジオボタン1");
        radio1.setTextColor(Color.rgb(0,0,0));
        
        //ラジオグループの生成(2)
        radioGroup=new RadioGroup(this);
        radioGroup.addView(radio0);
        radioGroup.addView(radio1);     
        radioGroup.check(0);
        setLLParams(radioGroup);        
        layout.addView(radioGroup);        

        //ボタンの生成
        button=new Button(this);
        button.setText("結果表示");
        button.setOnClickListener(this);
        setLLParams(button);
        layout.addView(button);
    }

    //ボタンクリックイベントの処理
    public void onClick(View v) {
        //チェックボックスとラジオボタンの状態取得(1)(2)
        showDialog(this,"",
            "チェックボックス>"+checkBox.isChecked()+BR+
            "ラジオボタン>"+radioGroup.getCheckedRadioButtonId());
    }    
    
    //ダイアログの表示
    private static void showDialog(final Activity activity,
        String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(activity);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                activity.setResult(Activity.RESULT_OK);
            }
        });
        ad.create();
        ad.show();
    }    
    
    //ライナーレイアウトのパラメータ指定
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }  
}