package net.npaka.edittextex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;

//エディットテキスト
public class EditTextEx extends Activity 
    implements View.OnClickListener {
    private EditText     editText;//エディットテキスト
    private Button       button;  //ボタン
    
    //アプリの初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);       
        
        //エディットテキストの生成(1)
        editText=new EditText(this);
        editText.setText("これはテストです",
            EditText.BufferType.NORMAL);
        setLLParams(editText,240,50);
        layout.addView(editText);
        
        //ボタンの生成
        button=new Button(this);
        button.setText("結果表示");
        button.setOnClickListener(this);
        setLLParams(button);  
        layout.addView(button);
    }

    //ボタンクリックイベントの処理
    public void onClick(View v) {
        showDialog(this,"",//(1)
            "エディット>"+editText.getText().toString());
    }    
    
    //ダイアログの表示
    private static void showDialog(final Activity activity,
        String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(activity);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                activity.setResult(Activity.RESULT_OK);
            }
        });
        ad.create();
        ad.show();
    }    
    
    //ライナーレイアウトのパラメータ指定
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }  

    //ライナーレイアウトのパラメータ指定
    private static void setLLParams(View view,int w,int h) {
        view.setLayoutParams(new LinearLayout.LayoutParams(w,h));
    }
}