package net.npaka.optionmenuex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Color;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.LinearLayout;

//オプションメニュー
public class OptionMenuEx extends Activity {
    //メニューアイテムID
    private static final int 
        MENU_ITEM0=0,
        MENU_ITEM1=1,
        MENU_ITEM2=2;

    //アプリの初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 
    }

    //オプションメニューの生成(1)
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        
        //メニューアイテム0の追加(2)
        MenuItem item0=menu.add(0,MENU_ITEM0,
            0,R.string.menu_item0);
        item0.setIcon(android.R.drawable.ic_menu_add);
        
        //メニューアイテム1の追加
        MenuItem item1=menu.add(0,MENU_ITEM1,
            0,R.string.menu_item1);
        item1.setIcon(android.R.drawable.ic_menu_call);
        
        //メニューアイテム2の追加
        MenuItem item2=menu.add(0,MENU_ITEM2,0,
            R.string.menu_item2);
        item2.setIcon(android.R.drawable.ic_menu_save);
        return true;
    }    

    //(3)メニューアイテム選択イベントの処理
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case MENU_ITEM0:
                showDialog(this,"","アイテム0を押した");
                return true;
            case MENU_ITEM1:
                showDialog(this,"","アイテム1を押した");
                return true;
            case MENU_ITEM2:
                showDialog(this,"","アイテム2を押した");
                return true;
        }
        return true;
    }    
    
    //ダイアログの表示
    private static void showDialog(final Activity activity,
        String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(activity);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                activity.setResult(Activity.RESULT_OK);
            }
        });
        ad.create();
        ad.show();
    }
}