package net.npaka.textviewex;
import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.ImageView;

//テキストビューとイメージビュー
public class TextViewEx extends Activity {
    //初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成(1)
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 

        //テキストビューの生成(2)
        TextView textView=new TextView(this);
        textView.setText("これはテストです");
        textView.setTextSize(16.0f);                  
        textView.setTextColor(Color.rgb(0,0,0));
        
        //コンポーネントのサイズの指定(3)
        setLLParams(textView);
        
        //レイアウトへのコンポーネントの追加(4)
        layout.addView(textView);

        //画像の読み込み
        Bitmap bitmap=BitmapFactory.decodeResource(
            getResources(),R.drawable.mini);

        //イメージビューの生成(5)
        ImageView imageView=new ImageView(this);
        imageView.setImageBitmap(bitmap);
        setLLParams(imageView);
        layout.addView(imageView);
    }  

    //ライナーレイアウトのパラメータ指定
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }
}