package net.npaka.videoviewex;
import android.app.Activity;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.LinearLayout;
import android.widget.VideoView;
import android.widget.MediaController;

//ビデオビュー
public class VideoViewEx extends Activity {
    private final static String URL=
        "http://www.saturn.dti.ne.jp/~npaka/android/sample.mp4";
    
    //アプリの初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);        
        
        //ビデオビューの生成(1)
        VideoView videoView=new VideoView(this);
        videoView.requestFocus();
        videoView.setMediaController(new MediaController(this));
        setLLParams(videoView);
        layout.addView(videoView);

        //動画の再生(2)
        try {
            videoView.setVideoURI(Uri.parse(URL));        
        } catch (Exception e) {
        }
    }
    
    //ライナーレイアウトのパラメータ指定
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }
}