package net.npaka.webviewex;
import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.Window;
import android.webkit.JsResult;
import android.webkit.WebView;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;

//WEBビュー
public class WebViewEx extends Activity {
    private WebView webView;//Webビュー
    private Handler handler;//ハンドラー

    //アプリの初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //ハンドラーの生成
        handler=new Handler();    
        
        //WEBビューの生成(1)
        webView=new WebView(this);       
        WebSettings settings=webView.getSettings();
        settings.setJavaScriptEnabled(true);
        settings.setSavePassword(false);
        settings.setSaveFormData(false);
        settings.setSupportZoom(false);

        //JavaScriptインタフェースの生成
        webView.addJavascriptInterface(new JSInterface(),"demo");
        
        //WebChromeClientクラスの継承クラスの生成
        webView.setWebChromeClient(new ChromeClient());
        
        //HTMLの読み込み(4)
        webView.loadUrl("file:///android_asset/sample.html");
        setContentView(webView); 
    }

    //JavaScriptインタフェースの生成(2)
    public final class JSInterface {
        //コンストラクタ
        public JSInterface() {
        }

        //JavaScriptインタフェースのメソッドの処理(5)
        public void onClick() {
            handler.post(new Runnable() {
                public void run() {
                    android.util.Log.e("","changeImage");
                    webView.loadUrl("javascript:changeImage()");
                }
            });
        }
    }

    //WebChromeClientクラスの継承ラスの生成(3)
    public final class ChromeClient extends WebChromeClient {
        //アラートイベントの処理
        @Override
        public boolean onJsAlert(WebView view,String url,String message,JsResult result) {
            android.util.Log.e("",message);
            result.confirm();
            return true;
        }
    }
}