package net.npaka.socketex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RelativeLayout;
import android.widget.TextView;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

//ソケット通信
public class SocketEx extends Activity    
    implements View.OnClickListener {
    private final static String BR=//改行
        System.getProperty("line.separator");
    private final static String IP=//IPアドレスの指定(1)
        "192.168.11.17";//★変更必須
    
    private SocketEx current;   //カレント
    private TextView lblReceive;//受信ラベル
    private EditText edtSend;   //送信エディットテキスト
    private Button   btnSend;   //送信ボタン
    
    private Socket       socket; //ソケット
    private InputStream  in;     //入力ストリーム
    private OutputStream out;    //出力ストリーム  
    
    private final Handler handler=new Handler();//ハンドラ(6)
    private String txtReceive;//受信テキスト    
    
    //初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        current=this;
        
        //レイアウトの生成(8)
        RelativeLayout layout=new RelativeLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        setContentView(layout);  
        
        //受信ラベルの生成
        lblReceive=new TextView(this);
        lblReceive.setId(1);//(9)
        lblReceive.setText("");
        lblReceive.setTextSize(16.0f);                  
        lblReceive.setTextColor(Color.rgb(0,0,0));
        RelativeLayout.LayoutParams param1=//(9)
            new RelativeLayout.LayoutParams(320,400);
        lblReceive.setLayoutParams(param1);
        layout.addView(lblReceive);

        //送信エディットテキストの生成
        edtSend=new EditText(this);
        edtSend.setId(2);//(9)
        edtSend.setText("",TextView.BufferType.NORMAL);
        RelativeLayout.LayoutParams param2=//(9)
            new RelativeLayout.LayoutParams(200,50);
        param2.addRule(RelativeLayout.BELOW,1);
        edtSend.setLayoutParams(param2);
        layout.addView(edtSend);        
        
        //送信ボタンの生成
        btnSend=new Button(this);
        btnSend.setText("送信");
        btnSend.setOnClickListener(this);
        RelativeLayout.LayoutParams param3=//(9)
            new RelativeLayout.LayoutParams(200,50);
        param3.addRule(RelativeLayout.BELOW,1);
        param3.addRule(RelativeLayout.RIGHT_OF,2);
        btnSend.setLayoutParams(param3);
        layout.addView(btnSend);

        //スレッドの生成(2)
        (new Thread(){public void run() {
            try {
                connect(IP,8080);
            } catch (Exception e) {
            }
        }}).start();      
    }
    
    //接続
    private void connect(String ip,int port) {
        int size;
        byte[] w=new byte[1024];        
        txtReceive="";
        try {
            //ソケット接続(3)
            socket=new Socket(ip,port);
            in =socket.getInputStream();
            out=socket.getOutputStream();
            
            //受信ループ(4)
            while (socket!=null && socket.isConnected()) {
                //データの受信(5)
                size=in.read(w);
                if (size<=0) continue;
                txtReceive=new String(w,0,size,"UTF-8");

                //ハンドラによるユーザーインタフェース操作(6)
                handler.post(new Runnable(){
                    public void run() {
                        //ラベルへの文字列追加
                        lblReceive.setText(
                            lblReceive.getText()+txtReceive+BR);
                    }
                });
            }
        } catch (Exception e) {
            handler.post(new Runnable(){
                public void run() {
                	SocketEx.showDialog(current,"","通信エラーです");
                }
            });
        }
    }    

    //ボタンクリックイベントの処理
    public void onClick(View v) {
        if (v==btnSend) {
            try {
                //データの送信(7)
                if (socket!=null && socket.isConnected()) {
                    byte[] w=edtSend.getText().toString().getBytes("UTF8");
                    out.write(w);
                    out.flush();
                    edtSend.setText("",TextView.BufferType.NORMAL);
                }
            } catch (Exception e) {
                handler.post(new Runnable(){
                    public void run() {
                    	SocketEx.showDialog(current,"","通信エラーです");
                    }
                });
            }           
        }
    }    
    
    //ダイアログの表示
    public static void showDialog(final Activity activity,String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(activity);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                activity.setResult(Activity.RESULT_OK);
            }
        });
        ad.create();
        ad.show();
    }
}