package net.npaka.fileproviderex;
import android.app.*;
import android.content.*;
import android.os.*;
import android.view.*;
import android.webkit.*;
import java.io.*;

//ファイルを提供するコンテントプロバイダの利用
public class FileProviderEx extends Activity {
    
    //初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        
        //Rawリソースのファイル保存(1)
        try {
            raw2file(this,R.raw.index,"index.html");
            raw2file(this,R.raw.image,"image.jpg");
        } catch (Exception e) {
        }
        
        //Webビューの生成
        WebView webView=new WebView(this);
        setContentView(webView); 
        
        //コンテントプロバイダが提供するファイルへのアクセス(2)
        webView.loadUrl("content://net.npaka.fileprovider/index.html");
    }

    //Rawリソースのファイル保存(1)
    private void raw2file(Context context,
        int resID,String fileName) throws Exception {
        InputStream in=null;
        String path=context.getFilesDir().getAbsolutePath()+"/"+fileName;
        if (!(new File(path)).exists()) {
            in=context.getResources().openRawResource(resID);
            in2file(context,in,fileName);
        }
    }

    //入力ストリームのファイル保存
    private void in2file(Context context,
        InputStream in,String fileName) 
        throws Exception { 
        int size;
        byte[] w=new byte[1024]; 
        OutputStream out=null;
        try {
            out=context.openFileOutput(fileName,
                Context.MODE_WORLD_READABLE);
            while (true) { 
                size=in.read(w); 
                if (size<=0) break; 
                out.write(w,0,size); 
            };
            out.close();
            in.close();
        } catch (Exception e) {
            try {
                if (in !=null) in.close();
                if (out!=null) out.close();
            } catch (Exception e2) {
            }
            throw e;
        }
    }
}