package net.npaka.intentreceiverex;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.LinearLayout;

//インテントレシーバー
public class IntentReceiverEx extends Activity    
    implements View.OnClickListener {
    private Button btnCall;//呼び出しボタン
        
    //初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);         
        
        //ボタンの生成
        btnCall=new Button(this);
        btnCall.setText("インテントのブロードキャスト");
        btnCall.setOnClickListener(this);
        setLLParams(btnCall);
        layout.addView(btnCall);
    } 

    //ボタンクリックイベントの処理
    public void onClick(View v) {
        if (v==btnCall) {
            //インテントのブロードキャスト(1)
            Intent intent=new Intent("android.intent.action.VIEW");
            intent.putExtra("TEXT","インテントレシーバーのテストです");
            sendBroadcast(intent);
        }
    }
    
    //ライナーレイアウトのパラメータ指定
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }  
}