package net.npaka.myactivityex;
import android.app.Activity;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;

//自作アクティビティ
public class MyActivity extends Activity 
    implements View.OnClickListener {
    private EditText editText;//エディットテキスト
    private Button   btnOK;   //OKボタン
    
    //初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //インテントからのパラメータ取得(5)
        String text="";
        Bundle extras=getIntent().getExtras();
        if (extras!=null) text=extras.getString("text");

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);               
        
        //OKボタンの生成
        btnOK=new Button(this);
        btnOK.setText("OK");
        btnOK.setOnClickListener(this);
        setLLParams(btnOK);
        layout.addView(btnOK);

        //エディットテキストの生成
        editText=new EditText(this);
        editText.setText(text);
        setLLParams(editText);
        layout.addView(editText);    
    }

    //ボタンクリックイベントの処理
    public void onClick(View v) {
        if (v==btnOK) {
            //戻り値パラメータの保存            
            SharedPreferences pref=getSharedPreferences(
                "PREVIOUS_RESULT",MODE_PRIVATE);
            SharedPreferences.Editor editor=pref.edit();
            editor.putString("text",editText.getText().toString());
            editor.commit();

            //アクティビティの終了(6)           
            setResult(RESULT_OK); 
            finish();
        }
    } 
    
    //ライナーレイアウトのパラメータ指定
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }  
}