package net.npaka.myactivityex;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

//自作アクティビティの呼び出し
public class MyActivityEx extends Activity 
    implements View.OnClickListener {
    private final static int REQUEST_TEXT=0;//テキストID
    
    private TextView textView;//テキストビュー
    private Button   btnCall; //呼び出しボタン
        
    //初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);          

        //呼び出しボタンの生成
        btnCall=new Button(this);
        btnCall.setText("MyActivityの呼び出し");
        btnCall.setOnClickListener(this);   
        setLLParams(btnCall);
        layout.addView(btnCall);        
        
        //テキストビューの生成
        textView=new TextView(this);
        textView.setText("This is TEST!");        
        textView.setTextColor(Color.rgb(0,0,0));
        setLLParams(textView);
        layout.addView(textView);        
    }

    //ボタンクリックイベントの処理
    public void onClick(View v) {
        if (v==btnCall) {
            //明示的なインテントの生成(1)
            Intent intent=new Intent(this,
                net.npaka.myactivityex.MyActivity.class);
            
            //インテントへのパラメータ付加(2)
            intent.putExtra("text",textView.getText().toString());
            
            //リクエストコード付きインテントの呼び出し(3)
            startActivityForResult(intent,REQUEST_TEXT);
        }
    } 
    
    //アクティビティ呼び出し結果の取得(4)
    @Override
    protected void onActivityResult(int requestCode,int resultCode,Intent intent) {
        if (requestCode==REQUEST_TEXT && resultCode==RESULT_OK) {
            //戻り値パラメータの取得
            SharedPreferences pref=getSharedPreferences(
                "PREVIOUS_RESULT",MODE_PRIVATE);
            textView.setText(pref.getString("text",""));
        }
    }    

    //ライナーレイアウトのパラメータ指定
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }  
}