package net.npaka.serviceex;
import android.app.PendingIntent;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.media.MediaPlayer;
import android.os.IBinder;
import android.widget.Toast;

//プレーヤーサービス
public class PlayerService extends Service {//(3)
    private NotificationManager nm;//ノティフィケーションマネージャ
    private MediaPlayer player;    //プレーヤー

    //初期化
    @Override
    public void onCreate() {
        //ノティフィケーションマネージャの取得(4)
        nm=(NotificationManager)getSystemService(
            Context.NOTIFICATION_SERVICE);

        //プレーヤーの生成
        try {
            player=MediaPlayer.create(this,R.raw.sample);
            player.prepare();
        } catch (Exception e) {
        }        
    }
    
    //初期化
    @Override
    public void onStart(Intent intent,int startID) {
        //ノティフィケーションの表示
        showNotification(this,R.drawable.icon,
            "BGMを再生します",
            "プレイヤーサービス",
            "プレイヤーサービスを開始しました");

        //サウンドの再生
        try {
            player.seekTo(0);
            player.start();
        } catch (Exception e) {
        }
    }

    //後処理
    @Override
    public void onDestroy() {
        //ノティフィケーションのキャンセル(6)
        nm.cancel(0);
        
        //サウンドの停止および解放
        player.stop();
        player.release();
        
        //トーストの表示
        showToast(this,"プレーヤーサービスを停止しました");
    }
    
    //バインド
    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }
    
    //ノティフィケーションの表示
    private void showNotification(Context context,
        int iconID,String ticker,String title,String message) {
        //ノティフィケーションオブジェクトの生成(5)
        Notification notification=new Notification(iconID,
            ticker,System.currentTimeMillis());
        PendingIntent intent=PendingIntent.getActivity(context,0,
            new Intent(context,net.npaka.serviceex.ServiceEx.class),0);
        notification.setLatestEventInfo(context,
            title,message,intent);
        
        //ノティフィケーションのキャンセル(6)
        nm.cancel(0);
        
        //ノティフィケーションの表示(7)
        nm.notify(0,notification);
    }

    //トーストの表示
    private static void showToast(Context context,String text) {
        Toast.makeText(context,text,Toast.LENGTH_SHORT).show();
    }
}