package net.npaka.serviceex;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.LinearLayout;

//サービス
public class ServiceEx extends Activity     
    implements View.OnClickListener {
        
    //初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの生成
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);         

        //再生ボタンの生成
        layout.addView(makeButton(0,"プレーヤーサービスの開始"));
        layout.addView(makeButton(1,"プレーヤーサービスの停止"));
    }
 
    //ボタンの生成
    private Button makeButton(int id,String text) {
        Button button=new Button(this);
        button.setId(id);
        button.setText(text);
        button.setOnClickListener(this); 
        setLLParams(button);
        return button;        
    }    
    
    //ボタンクリックイベントの処理
    public void onClick(View v) {
        int id=v.getId();
        //プレーヤーサービスの開始(1)
        if (id==0) {
            Intent intent=new Intent(this,
                net.npaka.serviceex.PlayerService.class);
            startService(intent);
        } 
        //プレーヤーサービスの停止(2)
        else if (id==1) {
            Intent intent=new Intent(this,
                net.npaka.serviceex.PlayerService.class);
            stopService(intent);
        }
    }  
    
    //ライナーレイアウトのパラメータ指定
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }  
}