package net.npaka.appwidgetex;
import android.app.Activity;
import android.appwidget.AppWidgetManager;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;

//ホームスクリーンウィジェット設定画面
public class HSWidgetConfigure extends Activity 
    implements View.OnClickListener {
	private int appWidgetID;//ホームスクリーンウィジェットID
    private EditText edtTitle;//タイトル編集

    //初期化
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        
        //失敗時の結果コードの指定(1)
        setResult(RESULT_CANCELED);
        
        //レイアウトの指定
        setContentView(R.layout.appwidget_configure);
        
        //ウィジェットの関連づけ
        edtTitle=(EditText)findViewById(R.id.appwidget_title);
        findViewById(R.id.save_button).setOnClickListener(this);
        
        //ホームスクリーンウィジェットIDの取得(2)
        appWidgetID=AppWidgetManager.INVALID_APPWIDGET_ID;
        Bundle extras=getIntent().getExtras();
        if (extras!=null) {
        	appWidgetID=extras.getInt(
                AppWidgetManager.EXTRA_APPWIDGET_ID, 
                AppWidgetManager.INVALID_APPWIDGET_ID);
        }
        if (appWidgetID==AppWidgetManager.INVALID_APPWIDGET_ID) finish();
    }

    //クリックイベントの処理
    public void onClick(View v) {
    	//タイトルの書き込み
        saveTitle(this,appWidgetID,edtTitle.getText().toString());
        
        //ウィジェットの更新(3)
        AppWidgetManager appWidgetManager=AppWidgetManager.getInstance(this);
        HSWidgetProvider.updateAppWidget(this,appWidgetManager,appWidgetID);
        
        //成功時の結果コードの指定(4)
        Intent resultValue=new Intent();
        resultValue.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID,appWidgetID);
        setResult(RESULT_OK, resultValue);
        finish();
    }    
    
    //タイトルの書き込み
    public static void saveTitle(Context context,int id,String text) {
        SharedPreferences.Editor prefs=context.getSharedPreferences(
        	"net.npaka.appwidgetex.HSWidgetProvider",0).edit();
        prefs.putString("prefix_"+id,text);
        prefs.commit();
    }

    //タイトルの読み込み
    public static String loadTitle(Context context,int id) {
        SharedPreferences prefs=context.getSharedPreferences(
        	"net.npaka.appwidgetex.HSWidgetProvider",0);
        String title=prefs.getString("prefix_"+id,null);
        if (title!=null) {
            return title;
        } else {
            return "default";
        }
    }
}



