package net.npaka.appwidgetex;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.Context;
import android.widget.RemoteViews;
import java.util.Calendar;

//ホームスクリーンウィジェットプロバイダー
public class HSWidgetProvider extends AppWidgetProvider {//(5)
    private final static String BR=//改行
        System.getProperty("line.separator");
	
	//更新時のイベント処理
	public void onUpdate(Context context, AppWidgetManager m,int[] id) {
        for (int i=0;i<id.length;i++) {
            updateAppWidget(context,m,id[i]);
        }
    }

    //ホームスクリーンウィジェットの更新
    public static void updateAppWidget(Context context, 
    	AppWidgetManager m,int id) {
        //時刻の取得
        Calendar cal=Calendar.getInstance();
        int year  =cal.get(Calendar.YEAR);
        int month =cal.get(Calendar.MONTH)+1;
        int day   =cal.get(Calendar.DAY_OF_MONTH);
        int hour  =cal.get(Calendar.HOUR_OF_DAY);
        int minute=cal.get(Calendar.MINUTE);
        int second=cal.get(Calendar.SECOND);
        
        //時刻文字列の生成
        CharSequence text=
        	HSWidgetConfigure.loadTitle(context,id)+BR+
            year+"/"+num2str(month)+"/"+num2str(day)+BR+
            num2str(hour)+":"+num2str(minute)+":"+num2str(second);
        
        //ホームスクリーンウィジェットの更新(6)
        RemoteViews views=new RemoteViews(context.getPackageName(),
        	R.layout.appwidget_provider);
        views.setTextViewText(R.id.appwidget_text,text);
        m.updateAppWidget(id,views);
    }
    
    //数値の補正
    private static String num2str(int num) {
    	if (num<10) return "0"+num;
    	return ""+num;
    }
}


