package net.npaka.sensorex;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.View;

//加速度センサーの利用
public class SensorView extends View {
    private float[] acceleration=new float[3];//加速度
    private float[] orientation =new float[3];//傾き
    
    //コンストラクタ
    public SensorView(Context context) {
        super(context);
        setBackgroundColor(Color.WHITE);
    }
    
    //加速度の指定
    public void setAcceleration(float[] acceleration) {
        this.acceleration=acceleration;
    }    
    
    //傾きの指定
    public void setOrientation(float[] orientation) {
        this.orientation=orientation;
    }    
    
    //描画
    @Override 
    protected void onDraw(Canvas canvas) {
        //ペイント
        Paint paint=new Paint();       
        paint.setAntiAlias(true);
        paint.setTextSize(16);
        
        //値の表示
        canvas.drawText("SensorEx>",0,20,paint);
        canvas.drawText("X軸加速度:"+acceleration[0],0,20*2,paint);
        canvas.drawText("Y軸加速度:"+acceleration[1],0,20*3,paint);
        canvas.drawText("Z軸加速度:"+acceleration[2],0,20*4,paint);        
        canvas.drawText("方位:"    +orientation[0], 0,20*5,paint);
        canvas.drawText("ピッチ:"   +orientation[1], 0,20*6,paint);
        canvas.drawText("ロール:"   +orientation[2], 0,20*7,paint);
    }
}