package net.npaka.memotool;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;

//ユーティリティ(6)
public class Util {

    //文字列を任意の文字で分割
    public static String[] parseStr(String str,String sep) {
        int i,j,size;
        String[] result;
    
        //最後尾に分割文字
        if (str.equals("")||str.substring(
            str.length()-1)!=sep) str+=sep;
    
        //サイズを得る
        size=0;
        i=str.indexOf(sep);
        while (i>=0) {
            size++;
            i=str.indexOf(sep,i+1);
        }
    
        //分割する
        result=new String[size];
        size=0;
        j=0;
        i=str.indexOf(sep);
        while (i>=0) {
            result[size++]=str.substring(j,i);
            j=i+1;
            i=str.indexOf(sep,j);
        }
        return result;
    }    
    
    //ダイアログの表示
    public static void showDialog(final Activity activity,String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(activity);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                activity.setResult(Activity.RESULT_OK);
            }
        });
        ad.create();
        ad.show();
    }     
    
    //ファイル→文字列
    public static String file2str(Context context,
        String fileName) throws Exception {  
        byte[] w=file2data(context,fileName);
        return new String(w);
    }

    //ファイル→バイトデータ
    public static byte[] file2data(Context context,
        String fileName) throws Exception {
        int size;
        byte[] w=new byte[128]; 
        InputStream in=null;
        ByteArrayOutputStream out=null;
        try {
            in=context.openFileInput(fileName);
            out=new ByteArrayOutputStream();
            while (true) {
                size=in.read(w);
                if (size<=0) break;
                out.write(w,0,size);
            }
            in.close();
            out.close();
            return out.toByteArray();
        } catch (Exception e) {
            try {
                if (in!=null) in.close();
                if (out!=null) out.close();
            } catch (Exception e2) {
            }
            throw e;
        }
    }

    //文字列→ファイル
    public static void str2file(Context context,
        String str,String fileName) throws Exception {
        data2file(context,str.getBytes(),fileName);
    }

    //バイトデータ→ファイル
    public static void data2file(Context context,
        byte[] data,String fileName) throws Exception {
        OutputStream out=null;
        try {
            out=context.openFileOutput(fileName,
                Context.MODE_WORLD_READABLE);
            out.write(data,0,data.length);
            out.close();
        } catch (Exception e) {
            try {
                if (out!=null) out.close();
            } catch (Exception e2) {
            }
            throw e;
        }
    } 
}
