package net.npaka.broomfight;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Rect;
import android.view.SurfaceHolder;

//iアプリ風Graphicsクラス
public class DoJaGraphics {
    //色定数
    public static int AQUA   =(  0<<16)+(255<<8)+255;
    public static int BLACK  =(  0<<16)+(  0<<8)+  0;
    public static int BLUE   =(  0<<16)+(  0<<8)+255;
    public static int FUCHSIA=(255<<16)+(  0<<8)+255;
    public static int GRAY   =(128<<16)+(128<<8)+128;
    public static int GREEN  =(  0<<16)+(128<<8)+  0;
    public static int LIME   =(  0<<16)+(255<<8)+  0;
    public static int MAROON =(128<<16)+(  0<<8)+  0;
    public static int NAVY   =(  0<<16)+(  0<<8)+128;
    public static int OLIVE  =(128<<16)+(128<<8)+  0;
    public static int PURPLE =(128<<16)+(  0<<8)+128;
    public static int RED    =(255<<16)+(  0<<8)+  0;
    public static int SILVER =(192<<16)+(192<<8)+192;
    public static int TEAL   =(  0<<16)+(128<<8)+128;
    public static int WHITE  =(255<<16)+(255<<8)+255;
    public static int YELLOW =(255<<16)+(255<<8)+  0;
    
    //変数
    private SurfaceHolder holder;  //サーフェイスホルダー
    private Paint         paint;   //描画オブジェクト
    private Canvas        canvas;  //キャンバス
    private Rect          drawArea;//描画領域
    
    //コンストラクタ
    public DoJaGraphics(SurfaceHolder holder) {
        this.holder=holder;
        paint=new Paint();
        paint.setAntiAlias(true);
        paint.setTextSize(12);
        paint.setColor(Color.rgb(0,0,0));
        drawArea=new Rect(0,0,240,240);
    }
    
    //描画領域の指定(5)
    public void setDrawArea(int x,int y,int w,int h) {
        drawArea=new Rect(x,y,x+w,y+h);
    }
    
    //色値の取得
    public int getColorOfName(int colorName) {
        return colorName;    
    }
    
    //色値の取得
    public int getColorOfRGB(int r,int g,int b) {
        return (r<<16)+(g)+b;
    }
    
    //色の指定
    public void setColor(int color) {
        int r=(color>>16)&0xFF;
        int g=(color>> 8)&0xFF;
        int b=(color>> 0)&0xFF;
        paint.setColor(Color.argb(255,r,g,b));
    }
    
    //ロック
    public void lock() {
        canvas=holder.lockCanvas();
        canvas.clipRect(drawArea);  
    }
    
    //アンロック
    public void unlock(boolean flag) {
        holder.unlockCanvasAndPost(canvas);
    }
    
    //文字列の描画
    public void drawString(String str,int x,int y) {
        canvas.drawText(str,
            drawArea.left+x,drawArea.top+y,paint);
    }
    
    //イメージの描画
    public void drawImage(Bitmap image,int x,int y) {
        canvas.drawBitmap(image,
            drawArea.left+x,drawArea.top+y,null);
    }
}
