package net.npaka.droiddrawex;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageButton;

//XMLによるレイアウト作成
public class DroidDrawEx extends Activity 
    implements View.OnClickListener {
    private Button      button;     //ボタン
    private ImageButton imageButton;//イメージボタン

    //初期化
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //レイアウトの指定(1)
        setContentView(R.layout.sample);       
        
        //ウィジェットの関連づけ(2)
        button=(Button)this.findViewById(R.id.button);
        button.setOnClickListener(this);
        imageButton=(ImageButton)this.findViewById(
            R.id.imageButton);
        imageButton.setOnClickListener(this);
    }   
    
    //ボタンクリックイベントの処理(2)
    public void onClick(View view) {
        //ボタンを押した時の処理
        if (view==button) {
            showDialog(this,"","ボタンを押した ");
        } 
        //イメージボタンを押した時の処理
        else if (view==imageButton) {
            showDialog(this,"","イメージボタンを押した ");
        }
    }
    
    //ダイアログの表示
    private static void showDialog(final Activity activity,
        String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(activity);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                activity.setResult(Activity.RESULT_OK);
            }
        });
        ad.create();
        ad.show();
    }
}